package com.gxwebsoft.shop.controller;

import com.gxwebsoft.common.core.web.BaseController;
import com.gxwebsoft.shop.service.ChatConversationService;
import com.gxwebsoft.shop.entity.ChatConversation;
import com.gxwebsoft.shop.param.ChatConversationParam;
import com.gxwebsoft.common.core.web.ApiResult;
import com.gxwebsoft.common.core.web.PageResult;
import com.gxwebsoft.common.core.web.PageParam;
import com.gxwebsoft.common.core.web.BatchParam;
import com.gxwebsoft.common.core.annotation.OperationLog;
import com.gxwebsoft.common.system.entity.User;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.web.bind.annotation.*;

import javax.annotation.Resource;
import java.util.List;

/**
 * 聊天消息表控制器
 *
 * @author 科技小王子
 * @since 2024-04-27 16:08:04
 */
@Api(tags = "聊天消息表管理")
@RestController
@RequestMapping("/api/shop/chat-conversation")
public class ChatConversationController extends BaseController {
    @Resource
    private ChatConversationService chatConversationService;

    @ApiOperation("分页查询聊天消息表")
    @GetMapping("/page")
    public ApiResult<PageResult<ChatConversation>> page(ChatConversationParam param) {
        // 使用关联查询
        return success(chatConversationService.pageRel(param));
    }

    @ApiOperation("查询全部聊天消息表")
    @GetMapping()
    public ApiResult<List<ChatConversation>> list(ChatConversationParam param) {
        // 使用关联查询
        return success(chatConversationService.listRel(param));
    }

    @PreAuthorize("hasAuthority('shop:chatConversation:list')")
    @ApiOperation("根据id查询聊天消息表")
    @GetMapping("/{id}")
    public ApiResult<ChatConversation> get(@PathVariable("id") Integer id) {
        // 使用关联查询
        return success(chatConversationService.getByIdRel(id));
    }

    @ApiOperation("添加聊天消息表")
    @PostMapping()
    public ApiResult<?> save(@RequestBody ChatConversation chatConversation) {
        // 记录当前登录用户id
        // User loginUser = getLoginUser();
        // if (loginUser != null) {
        //  chatConversation.setUserId(loginUser.getUserId());
        // }
        if (chatConversationService.save(chatConversation)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("修改聊天消息表")
    @PutMapping()
    public ApiResult<?> update(@RequestBody ChatConversation chatConversation) {
        if (chatConversationService.updateById(chatConversation)) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("删除聊天消息表")
    @DeleteMapping("/{id}")
    public ApiResult<?> remove(@PathVariable("id") Integer id) {
        if (chatConversationService.removeById(id)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

    @ApiOperation("批量添加聊天消息表")
    @PostMapping("/batch")
    public ApiResult<?> saveBatch(@RequestBody List<ChatConversation> list) {
        if (chatConversationService.saveBatch(list)) {
            return success("添加成功");
        }
        return fail("添加失败");
    }

    @ApiOperation("批量修改聊天消息表")
    @PutMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody BatchParam<ChatConversation> batchParam) {
        if (batchParam.update(chatConversationService, "id")) {
            return success("修改成功");
        }
        return fail("修改失败");
    }

    @ApiOperation("批量删除聊天消息表")
    @DeleteMapping("/batch")
    public ApiResult<?> removeBatch(@RequestBody List<Integer> ids) {
        if (chatConversationService.removeByIds(ids)) {
            return success("删除成功");
        }
        return fail("删除失败");
    }

}
